SystemOrganization addCategory: #'FLOdactic-Core'!

Object subclass: #DidacticMaterial
	instanceVariableNames: 'authors contributors tags uri title created modified description type license status owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

DidacticMaterial class
	instanceVariableNames: 'owners'!

DidacticMaterial class
	instanceVariableNames: 'owners'!

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/7/2013 19:43'!
addAuthor: anAuthor
	"author := anAuthor."
	authors add: anAuthor name -> anAuthor.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/9/2013 21:46'!
addContributor: aContributor
	contributors add: aContributor name -> aContributor.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/6/2013 20:22'!
addTag: aTag
	"comment stating purpose of message"

	tags := aTag.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/6/2013 20:19'!
authors
	^ authors.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:31'!
description
	^ description.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:40'!
description: aString 
	description := aString.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/9/2013 21:47'!
initialize
	super initialize.
	
	"No attribute is mandatory at this point, everything will be checked when it will be added"
	uri := nil.
	title := nil.
	description := nil.
	type := nil.
	license := nil.
	status := nil.
	
	"Agregations"
"	author := nil."
	contributors := Dictionary new.
	authors := Dictionary new.
"	owners := nil."
	
	
! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:33'!
license
	^ license.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:40'!
license: aString 
	license := aString.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/7/2013 19:32'!
matchesAuthorsByName: anExpression
	"Returns true if at least one of the authors's name matches anExpression"

	| list |
	list := self selectAuthorsByName: anExpression.
	^ (list size) > 0.
! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/7/2013 05:39'!
owner: anUser 
	| username |
	username := anUser username.

"	(owners includesKey: username) ifTrue: [
		msg := 'User *', username, '* is already an owner for that material'."
		"counter := items at: aTagString."
		"tags add: aTagString -> (counter + 1)."
"	].
	[(owners at: username)] ifError: [
		msg := 'User *', username, '* has been added as owner'.
		owners add: username -> anUser.
	].
	Transcript show: msg; cr."
	owner := anUser.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/7/2013 19:32'!
selectAuthorsByName: anExpression
	"Selects all the authors whose names matches anExpression"

	^ authors select: [ :author | anExpression match: (author name)].
! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:33'!
status
	^ status.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:40'!
status: aString 
	status := aString.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/6/2013 20:22'!
tags
	"comment stating purpose of message"

	^ tags.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:31'!
title
	^ title.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:40'!
title: aString 
	title := aString.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:36'!
touch
	"Modifies the latest modification timestamp (similar to the touch *nix command)"

	modified := DateAndTime now.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:32'!
type
	^ type.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:34'!
type: aString 
	type := aString.
	self touch.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:29'!
uri
	^ uri.! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'afv 5/1/2013 21:34'!
uri: aString 
	uri := aString.
	self touch.! !

Object subclass: #DidacticMaterialsManager
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

DidacticMaterialsManager class
	instanceVariableNames: 'uniqueInstance'!

DidacticMaterialsManager class
	instanceVariableNames: 'uniqueInstance'!

!DidacticMaterialsManager class methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:04'!
singleton

	uniqueInstance ifNil: [
		Transcript show: 'Creating the singleton instance of DidacticMaterialManager...'; crlf.
		uniqueInstance := self basicNew initialize
	].
	^ uniqueInstance! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 11:56'!
addAll: aDictionary
	"Adds all the items on aDictionary to the internal structure"
	"TODO: check for possible errors (duplicated, missing attributes, etc)"

	items := aDictionary.! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 21:49'!
initialize
	"comment stating purpose of message"
	
	super initialize.
	items := Dictionary new.
	Transcript show: 'DidacticMaterialManager initialize'; cr.! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 19:00'!
items
	"Returns a Dictionary with the items within the structure.
	This returns a very deep copy of the actual items so modifications doesn't compromise the actual data, nor creates unwanted side effects."

	^ items veryDeepCopy.! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'it 5/9/2013 21:58'!
owner: anOwner add: aDidacticMaterial
	"Adds aDidacticMaterial to the internal structure. It also links that didactic material to anAuthor"
	self validate: aDidacticMaterial.
	
	Transcript show: 'The didactic material: *', aDidacticMaterial uri, '* DOESNT exists!!'; cr.
	aDidacticMaterial owner: anOwner.
	items add: aDidacticMaterial uri -> aDidacticMaterial.
	! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 19:56'!
remove
	items remove.! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 12:32'!
remove: anUriString
	"Removes from the structure anUriString. Raises errors on:
	- Non existing anUriString (verified with...)"
	
	| item test msg |
	test := items includesKey: anUriString.
	(test) ifTrue: [
		msg := 'The didactic material exists on the system, removing it...'.
		Transcript show: msg; crlf.
		item := items at: anUriString.
		items removeKey: anUriString.
	].
	(test) ifFalse: [
		msg := 'The didactic material doesnt exists on the system, cannot remove it...'.
		Transcript show: msg; crlf.
		"self error: msg"

	].! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 11:58'!
select: aFilter
	"Returns a structure (Dictionary) of filtered items by aFilter criteria
	This should emulates something like 'list comprehensions' in python. Cool we manage to achieve this!! =D
	"

	| result |
	result := DidacticMaterialsManager new.
	result addAll: (items select: aFilter).
	^ result.
	! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 10:16'!
size
	"Returns the size of the internal structure"

	^ items size.! !

!DidacticMaterialsManager methodsFor: 'as yet unclassified' stamp: 'it 5/9/2013 21:55'!
validate: aDidacticMaterial
	"validates the material"
	
	(aDidacticMaterial uri)
		ifNil: [
			self error: 'URI cannot be empty!!'.
		] 
		ifNotNil: [
			(items includesKey: (aDidacticMaterial uri))
				ifTrue: [
					"There is a DidacticMaterial with the same URI
					Checks if its not the same instance. Raise an error only if it's a different material"
					(aDidacticMaterial ~= (items at: (aDidacticMaterial uri)))
						ifTrue: [
							self error: 'Another didactic material with URI *', aDidacticMaterial uri, '* already exists!!'.
						]
				]
		].

	(aDidacticMaterial title) ifNil: [
		self error: 'Title cannot be empty!!'.
	].
! !

Object subclass: #FLOdacticFacade
	instanceVariableNames: 'users didacticMaterials tags loggedUser floogle search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

FLOdacticFacade class
	instanceVariableNames: 'uniqueInstance'!

FLOdacticFacade class
	instanceVariableNames: 'uniqueInstance'!

!FLOdacticFacade class methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:03'!
singleton

	uniqueInstance ifNil: [
		Transcript show: 'Creating the singleton instance of FLOdacticFacade...'; crlf.
		uniqueInstance := self basicNew initialize
	].
	^ uniqueInstance! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:24'!
addMaterial: aDidacticMaterial 
	"Adds a didactic material. The owner will be the logged in user"
	
	| test |
	test := self loggedInOrRaiseErrorIfNot
	test ifTrue: [
		aDidacticMaterial touch.
		didacticMaterials owner: loggedUser add: aDidacticMaterial.
	]! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 20:36'!
addUser: anUser 
	"Add an user
	This message doesn't needs login. This emulates self sign in to the system"
	
	users add: anUser.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:12'!
allDidacticMaterials
	^ didacticMaterials.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:18'!
allTags
	"comment stating purpose of message"

! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:04'!
allUsers
	"comment stating purpose of message"

	^ users.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:15'!
doLogin: aUsernameString password: aPasswordString
	"Performs the login to the system.
	Returns true if login was successfull, false if not
	Possible errors:
	- Already logged in
	- Wrong username or username doesn't exist (delegated to UsersManager class)
	- Wrong password (delegated to UsersManager class)
	- User disabled (delegated to UsersManager class)
	"

	| result msg error |
	
	error := false.
	loggedUser ifNil: [
		loggedUser := users doLogin: aUsernameString password: aPasswordString.
		msg := 'Welcome back to FLOdactic', aUsernameString.
	]
	ifNotNil: [
		msg := 'Someone is already loggedin, logoff if this is not you!!'.
		error := true.
	].
	result := loggedUser username = aUsernameString.
	Transcript show: msg; cr.
	error ifTrue: [
		self error: msg.
	].
	^ result.
	
! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:15'!
doLogout
	"comment stating purpose of message"

	loggedUser := nil.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 20:30'!
initialize

	users := UsersManager singleton.
	didacticMaterials := DidacticMaterialsManager singleton.
	tags := TagsManager singleton.
	
	search := SearchEngine new.
	
	Transcript show: 'Creating users interface...'; crlf.
	^ self! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 21:29'!
loggedInOrRaiseErrorIfNot
	"Checks if the user is logged in, and if not raises an error"

	| msg test |
	test := loggedUser = nil.
	test ifTrue: [ 
		msg := 'Not logged in, you must log in first in order to complete that action. No cookies for you my friend!!'.
		self error: msg; cr.
	].
	^ test not.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:57'!
loggedUser
	^ loggedUser! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 19:54'!
remove
	search remove.
	
	didacticMaterials remove.
	users remove.
	tags remove.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:11'!
removeDidacticMaterial: anUri 
	didacticMaterials remove: anUri.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/4/2013 09:05'!
removeUser: anUsernameString 
	users remove: anUsernameString.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:13'!
searchDidacticMaterials: aStringExpression
	"Returns an ordered collection with the search results by aStringExpression"

	^ search searchDidacticMaterials: aStringExpression.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:13'!
searchUsers: aStringExpression
	"Returns an ordered collection with the search results by aStringExpression"

	^ search searchUsers: aStringExpression.! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:04'!
updateUser: aNewUser
	"TODO"
	"If the username matches and the user is logged in then we accept aNewUser as the updated object"

	| loggedIn matches |
	loggedIn := self loggedInOrRaiseErrorIfNot
	loggedIn ifTrue: [
		matches := loggedUser username = aNewUser username.
		matches ifTrue: [
			users add: aNewUser username -> aNewUser.
		]
	]! !

!FLOdacticFacade methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 18:03'!
usersAsOrderedCollection
	^ users asOrderedCollection.! !

Object subclass: #Person
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

Person subclass: #Author
	instanceVariableNames: 'bio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

!Author methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:32'!
bio
	^ bio.! !

!Author methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:32'!
bio: aString
	bio := aString.! !

!Author methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 20:44'!
initialize
	super initialize.
	
	name := nil.
	bio := nil.! !

!Author methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:32'!
name
	^ name.! !

!Author methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:17'!
name: aString
	name := aString.! !

!Person methodsFor: 'accessing' stamp: 'afv 5/6/2013 20:15'!
initialize
	"comment stating purpose of message"

	super initialize.
	name := nil.! !

!Person methodsFor: 'accessing' stamp: 'afv 4/30/2013 22:08'!
name
	^ name.! !

!Person methodsFor: 'accessing' stamp: 'afv 4/30/2013 13:41'!
name: aString 
	name := aString.! !

Person subclass: #User
	instanceVariableNames: 'username password email role status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

!User commentStamp: 'afv 5/1/2013 20:44' prior: 0!
User class

Responsability: Represent a single user and its attributes!

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 22:00'!
email
	^ email! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 13:41'!
email: aString 
	email := aString.! !

!User methodsFor: 'accessing' stamp: 'afv 5/2/2013 19:06'!
hasEmptyPassword
	"comment stating purpose of message"

	^ password = nil.! !

!User methodsFor: 'accessing' stamp: 'afv 5/6/2013 20:16'!
initialize
	super initialize.
	
	"Mandatory user's attributes"
	username := nil.
	password := nil.
	email := nil.
	
	"Automatic attributes (defined by the manager)"
	role := nil.
	status := nil.! !

!User methodsFor: 'accessing' stamp: 'afv 5/2/2013 18:31'!
isEnabled
	^ status = 'enabled'.! !

!User methodsFor: 'accessing' stamp: 'afv 5/2/2013 19:23'!
matchUsername: aUsernameString matchPassword: aPasswordString 
	^ username = aUsernameString and: password = aPasswordString.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 13:40'!
password: aString 
	password := aString.! !

!User methodsFor: 'accessing' stamp: 'afv 5/10/2013 10:59'!
release
	"Not sure if this is right but we didn't find any way to actualy use the release message in a way that works as we think it should.
	Perhaps this is not a good practice but we intentionally throw the reference to that object and the garbage collector should
	do the rest of the trics (hopefully)"

	self initialize.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 22:01'!
role
	^ role.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 13:44'!
role: aString 
	role := aString.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 22:01'!
status
	^ status.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 14:00'!
status: aString 
	status := aString.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 15:39'!
username
	^ username.! !

!User methodsFor: 'accessing' stamp: 'afv 4/30/2013 13:39'!
username: aString 
	username := aString.! !

Object subclass: #SearchEngine
	instanceVariableNames: 'didacticMaterialsManager didacticMaterials resultsByTitle resultsByDescription searchResults usersManager users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 22:01'!
addFilter: aFilter
	"Applies aFilter to the searchResults and returns the new results OrderedCollection"

	| oldResults |
	oldResults := searchResults veryDeepCopy.
	^ oldResults select: aFilter.
"	^ searchResults."
	! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 20:02'!
checkNullResults
	"comment stating purpose of message"

	| test |
	test := searchResults = nil.
	(test) ifTrue: [
		self error: 'You must first search and then add filters to the results.'.
	].
	^ test.! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 19:55'!
checkNullSearch: input
	"comment stating purpose of message"

	| test |
	test := input = ''.
	(test) ifTrue: [
		self error: 'Invalid search or filter expression.'.
	].
	^ test.! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/7/2013 19:42'!
filterByAuthor: anAuthorNameString
	"Filter expression by Author's name"

	"okay here's another crazy idea... this should return a block that acts as a filter,
	so the filter strategy is a generic algorithm with just 'plugins' of code!!"
	| test searchExpression |
	self checkNullSearch: anAuthorNameString.
	test := self checkNullResults.
	test ifFalse: [
		searchExpression := self wildCardExpression: anAuthorNameString.
		^ [ :didacticMaterial | didacticMaterial matchesAuthorsByName: searchExpression].
	].! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:06'!
initialize
	super initialize.
	didacticMaterialsManager := DidacticMaterialsManager singleton.
	didacticMaterials := didacticMaterialsManager items.
	
	usersManager := UsersManager singleton.
	users := usersManager items.
	searchResults := nil.! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 19:56'!
remove
	""! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:07'!
searchDidacticMaterials: aStringExpression
	"Returns an ordered collection of foun items by aStringExpression by all fields
	Later filters can by applied to narrow search results (as with google for instance)"

	| searchExpression test |
	test := self checkNullSearch: aStringExpression.
	(test) ifFalse: [
		searchExpression := '*', aStringExpression, '*'. "let's put some wildcards on it"
		resultsByTitle := (didacticMaterialsManager select: [:didacticMaterial | (searchExpression match: didacticMaterial title)]) items.
		resultsByDescription := (didacticMaterialsManager select: [:didacticMaterial | (searchExpression match: didacticMaterial title)]) items.
	
		"okay, here's a crazy idea... let's cast those results to Colleciton, and then addAll of them and return an OrderedCollection..."
		searchResults := (resultsByTitle asOrderedCollection) addAll: (resultsByDescription asOrderedCollection)..
	].
	^ searchResults! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/9/2013 22:07'!
searchUsers: aStringExpression
	"TODO"
	"Returns an ordered collection of foun items by aStringExpression by all fields
	Later filters can by applied to narrow search results (as with google for instance)"

	| searchExpression test |
	test := self checkNullSearch: aStringExpression.
	(test) ifFalse: [
		searchExpression := '*', aStringExpression, '*'. "let's put some wildcards on it"
		resultsByTitle := (didacticMaterialsManager select: [:didacticMaterial | (searchExpression match: didacticMaterial title)]) items.
		resultsByDescription := (didacticMaterialsManager select: [:didacticMaterial | (searchExpression match: didacticMaterial title)]) items.
	
		"okay, here's a crazy idea... let's cast those results to Colleciton, and then addAll of them and return an OrderedCollection..."
		searchResults := (resultsByTitle asOrderedCollection) addAll: (resultsByDescription asOrderedCollection)..
	].
	^ searchResults! !

!SearchEngine methodsFor: 'as yet unclassified' stamp: 'afv 5/6/2013 20:50'!
wildCardExpression: anExpression
	"Returns an expression surrounded by asterisk (wildcard search)"

	^ '*', anExpression, '*'. "let's put some wildcards on it"! !

Object subclass: #Tag
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

!Tag commentStamp: 'afv 5/1/2013 20:41' prior: 0!
Tag class

Responsability: Represent a single tag, it's a very simple class!

!Tag methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:35'!
name
	"Returns the tag's name"

	^ name! !

!Tag methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:34'!
name: aString
	"Sets the tag name to aString"

	name := aString! !

Object subclass: #TagsManager
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

TagsManager class
	instanceVariableNames: 'uniqueInstance'!

!TagsManager commentStamp: 'afv 5/1/2013 20:44' prior: 0!
TagsManager class

Respnsability: Manage all the tags within the system.

We used a Dictionary as a support structure to store the Tag objects. We choose to use a Dictionary instead of a Set since we pretend to dynamically update the count on DidacticMaterial associated with each tag, so we can have an idea on popular Tags.!

TagsManager class
	instanceVariableNames: 'uniqueInstance'!

!TagsManager class methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:04'!
singleton

	uniqueInstance ifNil: [
		Transcript show: 'Creating the singleton instance of TagsManager...'; crlf.
		uniqueInstance := self basicNew initialize
	].
	^ uniqueInstance! !

!TagsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 21:10'!
add: aTagString
	"Adds a tag to the internal structure.
	TODO: This doesnt makes much sense...
	I think it would be better to include this logic within the DidacticMaterialManager add message, so it will query if the Tag exist or not and do some stuff
	"

	| counter |
	(items includesKey: aTagString) ifTrue: [
		Transcript show: ' Tag already exists on the system, incrementing'.
		counter := items at: aTagString.
		items add: aTagString -> (counter + 1).
	].
	[(items at: aTagString)] ifError: [
		items add: aTagString -> 1.
		Transcript show: ' doesnt exists on the system, adding it...'.
	].! !

!TagsManager methodsFor: 'as yet unclassified' stamp: 'afv 5/1/2013 20:40'!
initialize
	"Initializes the TagsManager structures
	- items: a Dictionary. We could have used a Set instead, but we found interesting to have a numerical index incremented and decremented regarding DidacticMaterials associated with that particular tag.
	"
	
	super initialize.
	items := Dictionary new.
	Transcript show: 'TagsManager initialize'.! !

Object subclass: #UsersManager
	instanceVariableNames: 'items emailsSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FLOdactic-Core'!

UsersManager class
	instanceVariableNames: 'uniqueInstance'!

!UsersManager commentStamp: 'afv 5/1/2013 20:47' prior: 0!
UsersManager class

Responsability: Manage all the users on the system.

Restrictions:
	- Username cannot be empty (verified with testEmptyUsername)
	- Password cannot be empty (verified with testEmptyPassword)
	- Email cannot be empty (verified with testEmptyEmail)
	- Role cannot be empty (verified with testEmptyRole)
	- Status cannot be empty (verified with testEmptyStatus)
	- Usernames must be unique (verified via items dictionary [test: testDuplicatedUsername])
	- Emails must be unique (verified via emailsSet [test: testDuplicatedEmails])
	* Test class: UserTests!

UsersManager class
	instanceVariableNames: 'uniqueInstance'!

!UsersManager class methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:04'!
singleton

	uniqueInstance ifNil: [
		Transcript show: 'Creating the singleton instance of UsersManager...'; crlf.
		uniqueInstance := self basicNew initialize
	].
	^ uniqueInstance! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'it 5/9/2013 22:56'!
add: aUser
	"Adds a user to the structure.
	* Test class: UserTests
	"
	self validate: aUser.
	
	items add: (aUser username) -> aUser.
	emailsSet add: (aUser email) -> aUser.
	Transcript show: 'The user doesnt exists on the system, adding it...'; crlf.

! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 18:01'!
asOrderedCollection
	"comment stating purpose of message"

	^ items asOrderedCollection.! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'afv 5/2/2013 20:43'!
doLogin: aUsernameString password: aPasswordString
	"Authenticates the user into the system.
	Returns true if username/password matches the ones provided, false if not.
	Possible errors:
	- Username missmatch. Test: testDoLoginWithNonExistingUsername
	- Password missmatch. Test: testDoLoginWithWrongPassword
	- User is disabled. Test:
	"
	| user test acceptedAuth msg error |
	user := nil.
	test := items includesKey: aUsernameString.
	(test) ifFalse: [
		msg := 'User doesnt exist'.
		error := true.
	].
	(test) ifTrue: [
		user := items at: aUsernameString.
		error := false.
		acceptedAuth := user matchUsername: aUsernameString matchPassword: aPasswordString.
		acceptedAuth ifFalse: [
			msg := 'Wrong password. No cookies for you!!'.
			error := true.
		].
		acceptedAuth ifTrue: [
			acceptedAuth := acceptedAuth and: user isEnabled.
			acceptedAuth ifFalse: [
				msg := 'The user is disabled, you cannot login.'.
				error := true.
			].
			acceptedAuth ifTrue: [
				msg := 'User loged in'.
			].
		].
	].
	Transcript show: msg; cr.
	(error) ifTrue: [
		self error: msg; crlf.
	].
	^ user.! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'it 5/9/2013 22:56'!
initialize
	"self initialize"
	
	super initialize.
	items := Dictionary new.
	emailsSet := Dictionary new.
	Transcript show: 'UserManager initialize'.! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 10:47'!
items
	"Returns the internal structure"

	^ items.! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'afv 5/10/2013 11:05'!
remove: aUsername
	"Removes from the structure aUsername. Raises errors on:
	- Non existing aUsername (verified with testEmptyUsername)"
	
	| user test msg |
	test := items includes: aUsername.
	(test) ifTrue: [
		msg := 'The user exists on the system, removing it...'.
		Transcript show: msg; crlf.
		user := items at: aUsername.
		(emailsSet includes: aUsername) ifTrue: [
			emailsSet remove: (user email).
		].
		items removeKey: aUsername.
	].
	(test) ifFalse: [
		msg := 'The user doesnt exists on the system, cannot remove it...'.
		Transcript show: msg; crlf.
		self error: msg

	].! !

!UsersManager methodsFor: 'accessing' stamp: 'afv 5/10/2013 11:28'!
removeAll
	"comment stating purpose of message"

	! !

!UsersManager methodsFor: 'as yet unclassified' stamp: 'it 5/9/2013 22:53'!
validate: aUser
	"Validates the passed-in User and raises errors on:
	- empty username (verified with testEmptyUsername)
	- empty password (verified with testEmptyPassword)
	- empty email (verified with testEmptyEmail)
	- empty role (verified with testEmptyRole)
	- empty status (verified with testEmptyStatus)
	- repeated usernames (verified via items dictionary [test: testDuplicatedUsername])
	- repeated emails (verified via emailsSet [test: testDuplicatedEmails])
	"
	
	(aUser username) ifNil: [
		self error: 'Username cannot be empty!!'.
	].

	(aUser hasEmptyPassword) ifTrue: [
		self error: 'Password cannot be empty Mr. genious!!'.
	].

	(aUser name) ifNil: [
		self error: 'Name cannot be empty!!'.
	].

	(aUser email) ifNil: [
		self error: 'Email cannot be empty!!'.
	].

	(aUser role) ifNil: [
		self error: 'Role cannot be empty!!'.
	].

	(aUser status) ifNil: [
		self error: 'Status cannot be empty oh oh!!'.
	].

	(emailsSet includes: (aUser email)) ifTrue: [
		self error: 'A user with that email address already exists in the system!!'.
	].

	(items includesKey: (aUser username)) ifTrue: [
		"There is a User with the same username!!
		Checks if its not the same instance. Raise an error only if it's a different user"
		(aUser ~= (items at: (aUser username))) ifTrue: [
			self error: 'Cannot add that username, it already exists on the system. Did you forget the password? No cookies for you!!'.
		]
	].
! !
